
Please refer to http://usethesource.io/about/values.html for the origin of this text. This text
includes our Code of Conduct, which offers our basic social values, but first it lists a number of community values specific to meta programming and open-source software development.

## Main Principles

These are principles that we strive to uphold in the UseTheSource community.

* Metaprogramming, software language engineering and generic programming are cool 
* "real world" application (not just toy languages and toy examples)
* Striving for good design
   * design code for readability: clear and simple code
   * design for all programmers/users: clear and simple languages, API and UX 
   * avoid over-design, gold-plating and premature optimization
* Proper attribution
   * open copyright licenses
   * clear authorship/ownership trace
   * clear funding/sponsorship trace
   * due diligence with reuse of open-source
* Excellence
   * generic & simple
   * efficient & scalable 
   * accurate & correct
   * continuously tested & delivered
* Social
   * patience with both users and contributors
   * open to feedback
   * responsive
   * visibly active

## Contributor Code of Conduct

As Contributors of the UseTheSource community, we pledge to respect all people who contribute through reporting issues, posting feature requests, updating documentation, submitting pull requests or patches, and other activities.

We are committed to making participation in this community a harassment-free experience for everyone, regardless of level of experience, gender, gender identity and expression, sexual orientation, disability, personal appearance, body size, race, ethnicity, age, or religion.

Examples of unacceptable behavior by participants include the use of sexual language or imagery, derogatory comments or personal attacks, trolling, public or private harassment, insults, or other unprofessional conduct.

[Project Owners](/about/processes.html) have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct. Contributors who do not follow the Code of Conduct may be removed from the project team.

This code of conduct applies both within project spaces and in public spaces when an individual is representing the UseTheSource community or one of its projects.

Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by [opening an issue](https://github.com/usethesource/usethesource.github.io/issues) or contacting one or more of the [Project Owners](/projects/).

This Code of Conduct is adapted from the Contributor Covenant, version 1.1.0, available from <http://contributor-covenant.org/version/1/1/0/>

